Bug 1982344

Summary: Capsule syncing is not triggered by CV promotion
Product: Red Hat Satellite Reporter: Justin Sherrill <jsherril>
Component: Content ViewsAssignee: Samir Jha <sajha>
Status: CLOSED ERRATA QA Contact: Vladimír Sedmík <vsedmik>
Severity: high Docs Contact:
Priority: unspecified    
Version: 6.10.0CC: ahumbe, pcreech, vsedmik
Target Milestone: 6.10.0Keywords: Regression, Triaged
Target Release: Unused   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2021-11-16 14:12:34 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:

Description Justin Sherrill 2021-07-14 17:59:58 UTC
Despite settings enabling auto-syncing for LCEs and a capsule with pulpcore featues enabled, the syncing is not planned or executed after a CV promotion to a LCE.

Speculation:
```
[91, 100] in /home/vagrant/projects/katello/app/models/katello/concerns/smart_proxy_extensions.rb
    91:         def self.with_environment(environment, include_default = false)
    92:           byebug
    93:           features = [PULP_NODE_FEATURE]
    94:           features << PULP_FEATURE if include_default
    95: 
=>  96:           unscoped.with_features(features).joins(:capsule_lifecycle_environments).
    97:               where(katello_capsule_lifecycle_environments: { lifecycle_environment_id: environment.id })
    98:         end
    99: 
   100:         def self.sync_needed?(environment)
(byebug) with_features(features)
#<ActiveRecord::Relation []>
(byebug) features
["Pulp Node"]

```

But the smart proxy does have pulpcore enabled:
```
(byebug) SmartProxy.with_features("Pulpcore")
#<ActiveRecord::Relation [#<SmartProxy id: 1, name: "centos7-katello-devel-stable.example.com", url: "https://centos7-katello-devel-stable.example.com:9...", created_at: "2021-07-07 11:43:47", updated_at: "2021-07-07 11:43:47", pubkey: "ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAABAQDcY/T9fnvGYA...", expired_logs: "0", puppet_path: nil, download_policy: "on_demand">]>

```

Despite this, the method `sync_needed?(environment)` eventually returns false, preventing any sync actions from being planned.

Discussion thread at:
https://community.theforeman.org/t/auto-sync-of-smart-proxies-not-starting/24372/3

Comment 1 Justin Sherrill 2021-07-14 18:00:03 UTC
Created from redmine issue https://projects.theforeman.org/issues/33014

Comment 2 Justin Sherrill 2021-07-14 18:00:04 UTC
Upstream bug assigned to None

Comment 3 Bryan Kearney 2021-07-22 00:09:07 UTC
Moving this bug to POST for triage into Satellite since the upstream issue https://projects.theforeman.org/issues/33014 has been resolved.

Comment 4 Justin Sherrill 2021-08-09 16:51:58 UTC
*** Bug 1991495 has been marked as a duplicate of this bug. ***

Comment 5 Vladimír Sedmík 2021-08-10 13:09:05 UTC
Verified on 6.10.0 snap 12 - capsule is synced accordingly to the settings in Administer > Settings > Content > Sync Capsules after Content View promotion

Comment 8 errata-xmlrpc 2021-11-16 14:12:34 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory (Moderate: Satellite 6.10 Release), and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2021:4702